"use strict";var _util=require("./util");Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;function ownKeys(a,b){var c=Object.keys(a);if(Object.getOwnPropertySymbols){var d=Object.getOwnPropertySymbols(a);b&&(d=d.filter(function(b){return Object.getOwnPropertyDescriptor(a,b).enumerable})),c.push.apply(c,d)}return c}function _objectSpread(a){for(var b,c=1;c<arguments.length;c++)b=null==arguments[c]?{}:arguments[c],c%2?ownKeys(Object(b),!0).forEach(function(c){_defineProperty(a,c,b[c])}):Object.getOwnPropertyDescriptors?Object.defineProperties(a,Object.getOwnPropertyDescriptors(b)):ownKeys(Object(b)).forEach(function(c){Object.defineProperty(a,c,Object.getOwnPropertyDescriptor(b,c))});return a}function _defineProperty(a,b,c){return b in a?Object.defineProperty(a,b,{value:c,enumerable:!0,configurable:!0,writable:!0}):a[b]=c,a}class Validator{constructor(){var a=0<arguments.length&&arguments[0]!==void 0?arguments[0]:{},b=_objectSpread({},a);this.processing=!1,this.successful=!1,this.errors={},this.options=b}/**
     * Add new error message for given attribute
     *
     * @param  {string} attribute
     * @param  {string} message
     * @return {void}
     */add(a,b){this.has(a)||(this.errors[a]=[]),this.errors[a].includes(b)||this.errors[a].push(b)}/**
     * Determine if any errors exists for the given field or object.
     *
     * @param {string|null|Array} field
     */has(a){if((0,_util.isArray)(a))return(0,_util.is)(Object.keys(this.errors),a);var b=Object.prototype.hasOwnProperty.call(this.errors,a);if(!b){var c=Object.keys(this.errors).filter(b=>b.startsWith("".concat(a,"."))||b.startsWith("".concat(a,"[")));b=0<c.length}return b}/**
     * Get first message of field given
     * @param {Array|string} field
     * @returns {*}
     */first(a){if((0,_util.isArray)(a))for(var b=0;b<a.length;b++)if(Object.prototype.hasOwnProperty.call(this.errors,a[b]))return this.first(a[b]);return this.get(a)[0]}/**
     * Missed field method
     * @param {string|null} field
     */missed(){var a=0<arguments.length&&arguments[0]!==void 0?arguments[0]:null;return!this.has(a)}/**
     * Missed field method
     * @param {string|null} field
     */nullState(){var a=0<arguments.length&&arguments[0]!==void 0?arguments[0]:null;return this.has(a)?!this.has(a):null}/**
     * Determine if we have any errors.
     */any(){var a=0<arguments.length&&void 0!==arguments[0]?arguments[0]:[],b=!!(1<arguments.length&&void 0!==arguments[1])&&arguments[1];if(b){var d={};return a.length?(a.forEach(a=>d[a]=this.get(a)),d):{}}if(!a.length)return 0<Object.keys(this.errors).length;var c={};return a.forEach(a=>c[a]=this.get(a)),0<Object.keys(c).length}/**
     * Get field that error
     * @param {string} field
     * @returns {*|*[]}
     */get(a){return this.errors[a]||[]}/**
     * Get all errors
     * @returns {{}}
     */all(){return this.errors}/**
     * Fill the error object
     * @param errors
     */fill(a){for(var b in a)Object.prototype.hasOwnProperty.call(a,b)&&(a[b]instanceof Array||(a[b]=[a[b]]));this.errors=a}/**
     * Flush error
     */flush(){this.errors={}}/**
     * Clear one or all error fields.
     *
     * @param {String|undefined|Array} attribute
     */clear(a){if(!a)return this.flush();var b=Object.assign({},this.errors);(0,_util.isArray)(a)?a.map(a=>{Object.keys(b).filter(b=>b===a||b.startsWith("".concat(a,"."))||b.startsWith("".concat(a,"["))).forEach(a=>delete b[a])}):Object.keys(b).filter(b=>b===a||b.startsWith("".concat(a,"."))||b.startsWith("".concat(a,"["))).forEach(a=>delete b[a]),this.fill(b)}/**
     * Check if form still has error
     * @returns {boolean}
     */isValid(){return!this.any()}/**
     * Clear errors on keydown.
     *
     * @param {KeyboardEvent} event
     * @param {string} prefix
     */onKeydown(a){var b=1<arguments.length&&arguments[1]!==void 0?arguments[1]:"",{name:c}=a.target;if(c){var d="";b&&(d="".concat(b,".").concat(c)),this.clear([c,d])}}}var _default=new Validator;exports.default=_default;